﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Verse;
using RimWorld;

namespace VexedThings
{
    public class PawnsMechanical : DefModExtension
    {
        /// <summary>
        /// This is the stuff that makes the bodies of mechanical pawns not rot away, just like mechanoid corpses.
        /// </summary>
        public bool corpseRotting = true;
    }
	
    [StaticConstructorOnStartup]
    public static class PostInitializationTweaker
    {
        static PostInitializationTweaker()
        {
            foreach (ThingDef thingDef in DefDatabase<ThingDef>.AllDefs)
            {
                PawnsMechanical tweaker = thingDef.GetModExtension<PawnsMechanical>();
                if (tweaker != null)
                {
                    ThingDef corpseDef = thingDef?.race?.corpseDef;
                    if (corpseDef != null)
                    {
                        if (tweaker.corpseRotting)
                        {
                          corpseDef.comps.RemoveAll(compProperties => compProperties is CompProperties_Rottable);
                          corpseDef.comps.RemoveAll(compProperties => compProperties is CompProperties_SpawnerFilth);
                        }
                    }
                }
            }
        }
    }
}
